module ServicePack
  class ServiceCollection
    def add(service_name, service_class)
      services[service_name] = service_class
    end

    def instanciate(base, service_name)
      raise NotImplementedError, "#{service_name.inspect} service" unless added?(service_name)
      service_class = services[service_name]
      service_class.new(base)
    end

    def added?(service_name)
      services.key? service_name
    end

    private
    def services
      @services ||= {}
    end
  end
end
